#ifndef __GM_MCP_ICECREW_USERLIST_H__
#define __GM_MCP_ICECREW_USERLIST_H__

#include <glib-object.h>
#include <gtk/gtk.h>
#include "gm-mcp-package.h"

G_BEGIN_DECLS

/*
 * Type checking and casting macros
 */
#define GM_TYPE_MCP_ICECREW_USERLIST			\
		(gm_mcp_icecrew_userlist_get_type())
#define GM_MCP_ICECREW_USERLIST(obj)			\
		(G_TYPE_CHECK_INSTANCE_CAST((obj), GM_TYPE_MCP_ICECREW_USERLIST, \
		GmMcpIcecrewUserlist))
#define GM_MCP_ICECREW_USERLIST_CONST(obj)		\
		(G_TYPE_CHECK_INSTANCE_CAST((obj), GM_TYPE_MCP_ICECREW_USERLIST, \
		GmMcpIcecrewUserlist const))
#define GM_MCP_ICECREW_USERLIST_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_CAST((klass), GM_TYPE_MCP_ICECREW_USERLIST, \
		GmMcpIcecrewUserlistClass))
#define GM_IS_MCP_ICECREW_USERLIST(obj)			\
		(G_TYPE_CHECK_INSTANCE_TYPE((obj), GM_TYPE_MCP_ICECREW_USERLIST))
#define GM_IS_MCP_ICECREW_USERLIST_CLASS(klass)	\
		(G_TYPE_CHECK_CLASS_TYPE ((klass), GM_TYPE_MCP_ICECREW_USERLIST))
#define GM_MCP_ICECREW_USERLIST_GET_CLASS(obj)	\
		(G_TYPE_INSTANCE_GET_CLASS((obj), GM_TYPE_MCP_ICECREW_USERLIST, \
		GmMcpIcecrewUserlistClass))

/* Private structure type */
typedef struct _GmMcpIcecrewUserlistPrivate GmMcpIcecrewUserlistPrivate;

/*
 * Main object structure
 */
typedef struct _GmMcpIcecrewUserlist GmMcpIcecrewUserlist;
 
struct _GmMcpIcecrewUserlist {
	GmMcpPackage parent;
	
	/*< private > */
	GmMcpIcecrewUserlistPrivate *priv;
};

/*
 * Class definition
 */
typedef struct _GmMcpIcecrewUserlistClass 	GmMcpIcecrewUserlistClass;

struct _GmMcpIcecrewUserlistClass {
	GmMcpPackageClass parent_class;

	/* Signals */
	void (* player_added) (GmMcpIcecrewUserlist *obj, gint id,
			gchar const *icon, gchar const *sort);
	void (* player_removed) (GmMcpIcecrewUserlist *obj, gint id);
	void (* name_changed) (GmMcpIcecrewUserlist *obj, gint id,
			gchar const *sort);
	void (* state_changed) (GmMcpIcecrewUserlist *obj, gint id, 
			gchar const *icon, gchar const *sort);
	void (* rank_changed) (GmMcpIcecrewUserlist *obj, gint id,
			gchar const *icon, gchar const *sort);
};

GType gm_mcp_icecrew_userlist_get_type(void) G_GNUC_CONST;
GmMcpIcecrewUserlist *gm_mcp_icecrew_userlist_new(void);

G_END_DECLS
#endif /* __GM_MCP_ICECREW_USERLIST_H__ */
